﻿@using System;
@using System.Web.UI.WebControls
@using System.Linq;
@using System.Web;
@using System.Web.Mvc;
@using System.Collections.Generic;
@using Portal.Models.PurchaseReport;
@using System.Data;
@using Portal.Controllers;

@model Toyota.Common.Web.MVC.ModelHolder

@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}
<div style="display: table; border: 1px solid #142B94; background-color: #DEECFD; padding: 10px; width: 98%">
    @Html.Action("HeaderPurchaseReportInquiry", "PurchaseReport")
</div>

<div style="display: table; border: 1px solid #142B94; background-color: #DEECFD; padding: 10px; width: 98%">
    @Html.Action("PurchaseReportsInquiryPartial", "PurchaseReport")
</div>

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "GoodReceiptActualDetail";
    settings.HeaderText = "View Data Detail GR Amount";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(900);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(400);
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.ScrollBars = ScrollBars.Both;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ClientSideEvents.Shown = "OnShowHandlerGoodReceiptActual";
    settings.SetContent(() =>
    {
        Html.RenderPartial("GoodReceiptActualDetail", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "InvoiceActualDetail";
    settings.HeaderText = "View Data Detail Actual Amount";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(900);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(400);
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.ScrollBars = ScrollBars.Both;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ClientSideEvents.Shown = "OnShowHandlerInvoiceActual";
    settings.SetContent(() =>
    {
        Html.RenderPartial("InvoiceActualDetail", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "InvoiceOutstandingDetail";
    settings.HeaderText = "View Data Detail Outstanding Amount";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(880);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(400);
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.ScrollBars = ScrollBars.Both;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ClientSideEvents.Shown = "OnShowHandlerInvoiceOutstanding";
    settings.SetContent(() =>
    {
        Html.RenderPartial("InvoiceOutstandingDetail", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings => {
    settings.Name = "popupProgress";
    settings.ShowHeader = false;
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(150);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.SetContent(() =>
    {
        ViewContext.Writer.Write("<table cellpadding=\"2\" width=\"100%\" border=\"0\" style=\"padding-top:16px; padding-left:16px; padding-right:16px;\">");
        ViewContext.Writer.Write("<tr style=\"height:100%;text-align:center\">");
        ViewContext.Writer.Write("<td colspan=\"3\" class=\"thColumn\">");
        Html.DevExpress().Label(
            edtSettings =>
            {
                edtSettings.Name = "IPMessageLabel";
                edtSettings.EncodeHtml = false;
                edtSettings.Text = "Download in progress<br />Please wait...";
                edtSettings.ControlStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                edtSettings.ControlStyle.Wrap = DefaultBoolean.True;
                edtSettings.ControlStyle.Font.Bold = true;
            }).GetHtml();
        ViewContext.Writer.Write("</td></tr>");
        ViewContext.Writer.Write("<tr style=\"height:15px\"></tr>");
        ViewContext.Writer.Write("<tr><td align = \"center\" style=\"text-align:center;\">");
        Html.DevExpress().Image(
            setting =>
            {
                setting.Name = "IPProgressImage";
                setting.ImageUrl = "~/Content/Images/LoadingImage.gif";
            }).GetHtml();
        ViewContext.Writer.Write("</td>");
        ViewContext.Writer.Write("</tr></table>");
    });
}).GetHtml()

@section SlidingBottomPaneContent {
    @Html.DevExpress().TextBox(
        settings =>
        {
            settings.Name = "txtContent";
            settings.Height = 100;
            settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
        }).GetHtml()
}

@section Script{

     $(document).ready(function () {
        OnOIPClearButtonClick();
    });

    var paramVendorCode = '';
    var paramVendorName = '';
    var paramPeriodFrom = '';
    var paramPeriodTo = '';
    var searchVendorCd = '';
    var searchVendorName = '';
    var searchPeriodFrom = '';
    var searchPeriodTo = '';
    var searchStatus ='No';

    function ShowGoodReceiptActualDetail(s, e) {
        var i = '';
        var index = '';
        
        i = s.name.substring(20);
        index = i - (PurchaseReportsInquiry.GetPageIndex() * PurchaseReportsInquiry.cpPageSize);
        
        paramVendorCode = PurchaseReportsInquiry.cpSupplierCode[index];
        paramVendorName = PurchaseReportsInquiry.cpSupplierName[index];
        paramPeriodFrom = OIPPeriodeFromDate.GetText();
        paramPeriodTo = OIPPeriodeToDate.GetText();

        if (detailParamChecking(paramVendorCode, paramVendorName) == '0') {
            GoodReceiptActualDetail.Show();
        }
    }

    function OnOIPViewDetailGoodReceiptActualBeginCallback(s, e) {
        e.customArgs["VendorCode"] = paramVendorCode;
        e.customArgs["VendorName"] = paramVendorName;
        e.customArgs["PeriodFrom"] = paramPeriodFrom;
        e.customArgs["PeriodTo"] = paramPeriodTo;
    }

    function OnShowHandlerGoodReceiptActual(s, e) {
        GoodReceiptDetailGrid.PerformCallback();
    }

    function ShowInvoicingActualDetail(s, e) {
        var i = '';
        var index = '';
        
        i = s.name.substring(18);
        index = i - (PurchaseReportsInquiry.GetPageIndex() * PurchaseReportsInquiry.cpPageSize);

        paramVendorCode = PurchaseReportsInquiry.cpSupplierCode[index];
        paramVendorName = PurchaseReportsInquiry.cpSupplierName[index];
        paramPeriodFrom = OIPPeriodeFromDate.GetText();
        paramPeriodTo = OIPPeriodeToDate.GetText();

        if (detailParamChecking(paramVendorCode, paramVendorName) == '0') {
            InvoiceActualDetail.Show();
        }
    }

    function OnOIPViewDetailInvoiceActualBeginCallback(s, e) {
        e.customArgs["VendorCode"] = paramVendorCode;
        e.customArgs["VendorName"] = paramVendorName;
        e.customArgs["PeriodFrom"] = paramPeriodFrom;
        e.customArgs["PeriodTo"] = paramPeriodTo;
    }

    function OnShowHandlerInvoiceActual(s, e) {
        InvoiceActualDetailGrid.PerformCallback();
    }

    function ShowInvoicingOutstandingDetail(s, e) {
        var i = '';
        var index = '';
        
        i = s.name.substring(23);
        index = i - (PurchaseReportsInquiry.GetPageIndex() * PurchaseReportsInquiry.cpPageSize);

        paramVendorCode = PurchaseReportsInquiry.cpSupplierCode[index];
        paramVendorName = PurchaseReportsInquiry.cpSupplierName[index];
        paramPeriodFrom = OIPPeriodeFromDate.GetText();
        paramPeriodTo = OIPPeriodeToDate.GetText();
        
        if (detailParamChecking(paramVendorCode, paramVendorName) == '0') {
            InvoiceOutstandingDetail.Show();
        }
    }

    function OnOIPViewDetailInvoiceOutstandingBeginCallback(s, e) {
        e.customArgs["VendorCode"] = paramVendorCode;
        e.customArgs["VendorName"] = paramVendorName;
        e.customArgs["PeriodFrom"] = paramPeriodFrom;
        e.customArgs["PeriodTo"] = paramPeriodTo;
    }

    function OnShowHandlerInvoiceOutstanding(s, e) {
        InvoiceOutstandingDetailGrid.PerformCallback();
    }

    function detailParamChecking(vendorCode, vendorName) {
        var validate = '0';

        if (vendorCode == '' || vendorCode == null) {
            alert('ERROR: Vendor Code should not be empty');
            validate = '1';
        }
        else if (vendorName == '' || vendorName == null) {
            alert('ERROR: Vendor Name should not be empty');
            validate = '1';
        }

        return validate;
    }

    function OnOIPClearButtonClick(s, e) {
        OIPVendorCode.SetText('');
        OIPVendorName.SetText('');
        OIPPeriodeFromDate.SetText(GetLastMonth());
        OIPPeriodeToDate.SetText(GetToday());

        OnOIPSearchButtonClick(s, e);
        searchStatus ='No';
    }

    function GetLastMonth() {
        var d = new Date();
        d.setDate(d.getDate() - 30);
        var curDate = d.getDate();
        var curMonth = d.getMonth() + 1;
        var curYear = d.getFullYear();

        return (curDate + "." + curMonth + "." + curYear);
    }

    function GetToday() {
        var d = new Date();
        var curDate = d.getDate();
        var curMonth = d.getMonth() + 1;
        var curYear = d.getFullYear();

        return (curDate + "." + curMonth + "." + curYear);
    }

    function OnOIPSearchButtonClick(s, e) {
        searchVendorCd = OIPVendorCode.GetText();
        searchVendorName = OIPVendorName.GetText();
        searchPeriodFrom = OIPPeriodeFromDate.GetText();
        searchPeriodTo = OIPPeriodeToDate.GetText();
        var searchPeriodFromDt ='';
        var searchPeriodToDt ='';

        if (searchPeriodFrom != ''){ //|| searchPeriodFrom != null
            var searchPeriodFromArr = searchPeriodFrom.split('.');
            searchPeriodFromDt = new Date(searchPeriodFromArr[2] + '-' + searchPeriodFromArr[1] + '-' + searchPeriodFromArr[0]); 
        }
        else {
            searchPeriodFromDt ='';
        }
        
        if (searchPeriodTo != ''){ //|| searchPeriodTo != null            
            var searchPeriodToArr = searchPeriodTo.split('.');
            searchPeriodToDt = new Date(searchPeriodToArr[2] + '-' + searchPeriodToArr[1] + '-' + searchPeriodToArr[0]);
        }
        else {
            searchPeriodToDt ='';
        }
       
        searchStatus ='Yes';
        if (DateComparison(searchPeriodFrom, searchPeriodTo, searchPeriodFromDt, searchPeriodToDt) == '0') {
            PurchaseReportsInquiry.PerformCallback();
        }
    }

    function OnOIPViewBeginCallback(s, e) {
        e.customArgs["VendorCd"] = searchVendorCd;
        e.customArgs["VendorName"] = searchVendorName;
        e.customArgs["PeriodFrom"] = searchPeriodFrom;
        e.customArgs["PeriodTo"] = searchPeriodTo;
    }

    function DateComparison(periodFrom, periodTo, periodFromDt, periodToDt) {
        var validate = '0';
        if (periodFrom != ''){  //|| periodFrom != null
            if (periodTo != ''){ //|| periodTo != null
                if (periodFromDt > periodToDt) {
                    alert('ERROR: Period From cannot be greater than Period To');
                    validate = '1';
                }
            }
@*            else if (periodTo == ''){ //|| periodTo == null
                alert('ERROR: Period To cannot be Null');
                validate = '1';
            }*@
        }

        else if (periodTo != '' ){ //|| periodTo != null
            if (periodFrom != ''){ // || periodFrom != null
                if (periodFromDt > periodToDt) {
                    alert('ERROR: Period From cannot be greater than Period To');
                    validate = '1';
                }
            }
            else if (periodFrom == ''){//|| periodFrom == null
                alert('ERROR: Period From cannot be Null');
                validate = '1';
            }
        }

        //if ((periodFrom != '' || periodFrom != null) || (periodTo != '' || periodTo != null)) {
        //    if (periodFromDt > periodToDt) {
        //        alert('ERROR: Period From cannot be greater than Period To');
        //        validate = '1';
        //    }
        //}

        return validate;
    }

    function OIPDownloadClick(s, e) {
        searchVendorCd = OIPVendorCode.GetText();
        searchVendorName = OIPVendorName.GetText();
        searchPeriodFrom = OIPPeriodeFromDate.GetText();
        searchPeriodTo = OIPPeriodeToDate.GetText();

        if (DownloadValidation() == '0') {
            $.ajax({
                type: "post",
                url: "@Url.Content("~/PurchaseReport/CheckBeforeDownload")",
                data: {
                    vendorCd: searchVendorCd,
                    vendorName: searchVendorName,
                    periodFrom: searchPeriodFrom,
                    periodTo: searchPeriodTo,
                    desc :'PurchaseReport'
                },
                success: function(data) {
                    var splitMsg = data.Result.split('|');
                    if (splitMsg[0] == "E") {
                        alert(splitMsg[1]);
                    }
                    else {
                        OnOIPSearchButtonClick(s, e);
                        searchStatus ='No';
                        PurchaseReportDownload(data.SupplierCode, data.SupplierName, data.PeriodFrom, data.PeriodTo);
                    }
                },
                error: function(data) {
                    alert("Download Purchase Report Error");
                }
            });
        }
    }

    function PurchaseReportDownload(vendorCd, vendorName, periodFrom, periodTo) {
        $("#IPMessageLabel").text("Download in progress,\nPlease wait...");
        popupProgress.Show();

        $.fileDownload("PurchaseReport/DownloadPurchaseReport", {
            data:{
                vendorCd: vendorCd,
                vendorName: vendorName,
                periodFrom: periodFrom,
                periodTo: periodTo
            },
            successCallback: function(url) {
                popupProgress.Hide();
            },
            failCallback: function(responseHtml, url) {
                popupProgress.Hide();
                alert(responseHtml);
            }
        });
    }

    function DownloadValidation() {    
        var validate = '0';
        searchPeriodFrom = OIPPeriodeFromDate.GetText();
        searchPeriodTo = OIPPeriodeToDate.GetText();
        //alert(searchPeriodFrom);
        if (searchStatus =='Yes'){
            if (OIPVendorCode.GetText() == '') {
                alert("Please Fill Vendor Code");
                validate = '1';
            }
            else if (OIPVendorName.GetText() == '') {
                alert("Please Fill Vendor Name");
                validate = '1';
            }
            //else if (OIPPeriodeFromDate.GetText() == '') {
            //    alert("Please Fill Period From");
            //    validate = '1';
            //}
            else if (searchPeriodFrom != '' || searchPeriodTo != '') {
                //alert('asas');
                
                var searchPeriodFromDt ='';
                var searchPeriodToDt ='';

                if (searchPeriodFrom != ''){ //|| searchPeriodFrom != null
                    var searchPeriodFromArr = searchPeriodFrom.split('.');
                    searchPeriodFromDt = new Date(searchPeriodFromArr[2] + '-' + searchPeriodFromArr[1] + '-' + searchPeriodFromArr[0]); 
                }
                else {
                    searchPeriodFromDt ='';
                }
                
                if (searchPeriodTo != ''){ //|| searchPeriodTo != null            
                    var searchPeriodToArr = searchPeriodTo.split('.');
                    searchPeriodToDt = new Date(searchPeriodToArr[2] + '-' + searchPeriodToArr[1] + '-' + searchPeriodToArr[0]);
                }
                else {
                    searchPeriodToDt ='';
                }
    
                if (DateComparison(searchPeriodFrom, searchPeriodTo, searchPeriodFromDt, searchPeriodToDt) == '0') {
                    validate = '0';
                }
                else{
                    validate = '1';
                }
            }
        }
        else{
            if (searchPeriodFrom != '' || searchPeriodTo != '') {
                
                var searchPeriodFromDt ='';
                var searchPeriodToDt ='';

                if (searchPeriodFrom != ''){ //|| searchPeriodFrom != null
                    var searchPeriodFromArr = searchPeriodFrom.split('.');
                    searchPeriodFromDt = new Date(searchPeriodFromArr[2] + '-' + searchPeriodFromArr[1] + '-' + searchPeriodFromArr[0]); 
                }
                else {
                    searchPeriodFromDt ='';
                }
                
                if (searchPeriodTo != ''){ //|| searchPeriodTo != null            
                    var searchPeriodToArr = searchPeriodTo.split('.');
                    searchPeriodToDt = new Date(searchPeriodToArr[2] + '-' + searchPeriodToArr[1] + '-' + searchPeriodToArr[0]);
                }
                else {
                    searchPeriodToDt ='';
                }
    
                if (DateComparison(searchPeriodFrom, searchPeriodTo, searchPeriodFromDt, searchPeriodToDt) == '0') {
                    validate = '0';
                }
                else{
                    validate = '1';
                }
            }
        }
        return validate;
    }

    function OnOIPDownloadGRButtonClick(s, e) {
        searchVendorCd = paramVendorCode;
        searchVendorName = paramVendorName;
        searchPeriodFrom = OIPPeriodeFromDate.GetText();
        searchPeriodTo = OIPPeriodeToDate.GetText();

        if (DownloadValidation() == '0' && detailParamChecking(paramVendorCode, paramVendorName) == '0') {
            $.ajax({
                type: "post",
                url: "@Url.Content("~/PurchaseReport/CheckBeforeDownload")",
                data: {
                    vendorCd: searchVendorCd,
                    vendorName: searchVendorName,
                    periodFrom: searchPeriodFrom,
                    periodTo: searchPeriodTo,
                    desc :'GoodReceipt'
                },
                success: function(data) {
                    var splitMsg = data.Result.split('|');
                    if (splitMsg[0] == "E") {
                        alert(splitMsg[1]);
                    }
                    else {
                        OnOIPSearchButtonClick(s, e);
                        searchStatus ='No';
                        PurchaseGRReportDownload(data.SupplierCode, data.SupplierName, data.PeriodFrom, data.PeriodTo);
                    }
                },
                error: function(data) {
                    alert("Download Purchase Report Error");
                }
            });
        }
    }

    function PurchaseGRReportDownload(vendorCd, vendorName, periodFrom, periodTo) {
        $("#IPMessageLabel").text("Download in progress,\nPlease wait...");
        popupProgress.Show();

        $.fileDownload("PurchaseReport/DownloadPurchaseGRReport", {
            data:{
                vendorCd: vendorCd,
                vendorName: vendorName,
                periodFrom: periodFrom,
                periodTo: periodTo
            },
            successCallback: function(url) {
                popupProgress.Hide();
            },
            failCallback: function(responseHtml, url) {
                popupProgress.Hide();
                alert(responseHtml);
            }
        });
    }


    function OnOIPDownloadActualButtonClick(s, e) {
        searchVendorCd = paramVendorCode;
        searchVendorName = paramVendorName;
        searchPeriodFrom = OIPPeriodeFromDate.GetText();
        searchPeriodTo = OIPPeriodeToDate.GetText();

        if (DownloadValidation() == '0' && detailParamChecking(paramVendorCode, paramVendorName) == '0') {
            $.ajax({
                type: "post",
                url: "@Url.Content("~/PurchaseReport/CheckBeforeDownload")",
                data: {
                    vendorCd: searchVendorCd,
                    vendorName: searchVendorName,
                    periodFrom: searchPeriodFrom,
                    periodTo: searchPeriodTo,
                    desc :'InvoicingActual'
                },
                success: function(data) {
                    var splitMsg = data.Result.split('|');
                    if (splitMsg[0] == "E") {
                        alert(splitMsg[1]);
                    }
                    else {
                        OnOIPSearchButtonClick(s, e);
                        searchStatus ='No';
                        PurchaseActualReportDownload(data.SupplierCode, data.SupplierName, data.PeriodFrom, data.PeriodTo);
                    }
                },
                error: function(data) {
                    alert("Download Purchase Report Error");
                }
            });
        }
    }

    function PurchaseActualReportDownload(vendorCd, vendorName, periodFrom, periodTo) {
        $("#IPMessageLabel").text("Download in progress,\nPlease wait...");
        popupProgress.Show();

        $.fileDownload("PurchaseReport/DownloadPurchaseActualReport", {
            data:{
                vendorCd: vendorCd,
                vendorName: vendorName,
                periodFrom: periodFrom,
                periodTo: periodTo
            },
            successCallback: function(url) {
                popupProgress.Hide();
            },
            failCallback: function(responseHtml, url) {
                popupProgress.Hide();
                alert(responseHtml);
            }
        });
    }

    function OnOIPDownloadOutstandingButtonClick(s, e) {
        searchVendorCd = paramVendorCode;
        searchVendorName = paramVendorName;
        searchPeriodFrom = OIPPeriodeFromDate.GetText();
        searchPeriodTo = OIPPeriodeToDate.GetText();

        if (DownloadValidation() == '0' && detailParamChecking(paramVendorCode, paramVendorName) == '0') {
            $.ajax({
                type: "post",
                url: "@Url.Content("~/PurchaseReport/CheckBeforeDownload")",
                data: {
                    vendorCd: searchVendorCd,
                    vendorName: searchVendorName,
                    periodFrom: searchPeriodFrom,
                    periodTo: searchPeriodTo,
                    desc :'InvoicingOutstanding'
                },
                success: function(data) {
                    var splitMsg = data.Result.split('|');
                    if (splitMsg[0] == "E") {
                        alert(splitMsg[1]);
                    }
                    else {
                        OnOIPSearchButtonClick(s, e);
                        searchStatus ='No';
                        PurchaseOutstandingReportDownload(data.SupplierCode, data.SupplierName, data.PeriodFrom, data.PeriodTo);
                    }
                },
                error: function(data) {
                    alert("Download Purchase Report Error");
                }
            });
        }
    }

    function PurchaseOutstandingReportDownload(vendorCd, vendorName, periodFrom, periodTo) {
        $("#IPMessageLabel").text("Download in progress,\nPlease wait...");
        popupProgress.Show();

        $.fileDownload("PurchaseReport/DownloadPurchaseOutstandingReport", {
            data:{
                vendorCd: vendorCd,
                vendorName: vendorName,
                periodFrom: periodFrom,
                periodTo: periodTo
            },
            successCallback: function(url) {
                popupProgress.Hide();
            },
            failCallback: function(responseHtml, url) {
                popupProgress.Hide();
                alert(responseHtml);
            }
        });
    }
}